# jQuery Mobile Icon Pack

Extending jQuery Mobile's default icon set.

This repository offers two options. A set of 33 custom icons (the original Icon Pack). Icon categories include currency symbols, media control, social media, common application icons, and more. It also cleans up the original icons and makes them a little sharper. It also includes crisp hi-res icons for retina displays. The icon pack overrides the default icon set completely.

There's also an entire icon set using Twitter Bootstrap's [Font Awesome](http://fortawesome.github.com/Font-Awesome/). 249 icons which cover just about any icon you'd need in your application. The Font Awesome collection allows you to use these icons in conjunction with jQuery Mobile's default icon set.

Included in the Font Awesome icon set are all original icons, as well as the extended icons.

## Examples

[View the Original Icons](http://andymatthews.net/code/jQuery-Mobile-Icon-Pack/original/) | [View the Font Awesome Icons](http://andymatthews.net/code/jQuery-Mobile-Icon-Pack/font-awesome/)

## Quick start

Clone the git repo - `git clone git@github.com:commadelimited/jQuery-Mobile-Icon-Pack.git` - or [download it](https://github.com/commadelimited/jQuery-Mobile-Icon-Pack/zipball/master)

## Original Icon Pack Usage
Drop `jqm-icon-pack-2.0-original.css` and the associated images folder into your project. Image files are relative to the CSS file just like the original icons are. Use them just as you would the standard icons.

## Font Awesome Icon Pack Usage
Drop `jqm-icon-pack-3.0.0-fa.css` and the associated font folder into your project. Font files are relative to the CSS file just like the original icons are. Use them just as you would the standard icons.

## My License
Dual license: MIT/GPL

## Font Awesome License
Version 3.0 of the Font Awesome font, CSS, and LESS files are licensed under CC BY 3.0: http://creativecommons.org/licenses/by/3.0/ A mention of 'Font Awesome - http://fortawesome.github.com/Font-Awesome' in human-readable source code is considered acceptable attribution (most common on the web). If human readable source code is not available to the end user, a mention in an 'About' or 'Credits' screen is considered acceptable (most common in desktop or mobile software).
